<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_vertexupdate
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die;

/**
 * VertexUpdate Controller
 *
 * @package     Joomla.Administrator
 * @subpackage  com_vertexupdate
 * @since       0.0.9
 */
class VertexUpdateControllerVertexUpdate extends JControllerForm {
    function get_update() {
        if($this->pull_update()) {
            echo 'OK';
        } else {
            echo 'FAIL';
        }
        exit;
    }
    function update() {
        $jinput = JFactory::getApplication()->input;
        $updates = array_keys($jinput->get('update', [], 'ARRAY'));
		$directories = glob(JPATH_ROOT . '/templates/*' , GLOB_ONLYDIR);
		$directories = array_filter($directories, function($d){
			return file_exists($d . '/vertex.json');
        });
        if (!file_exists(JPATH_COMPONENT_ADMINISTRATOR . "/update.zip")) {
            $this->pull_update();
        }
        $zip = new \ZipArchive();
        if ($zip->open(JPATH_COMPONENT_ADMINISTRATOR . "/update.zip") === true) {
            foreach($directories as $d) {
                $bname = basename($d);
                if (in_array($bname, $updates)) {
                    $zip->extractTo($d);
                }
            }
            $zip->close();
            $app = JFactory::getApplication();
            $url = JRoute::_('index.php?option=com_vertexupdate', false);
            $app->redirect($url);
        } else {
            JFactory::getApplication()->enqueueMessage(JText::_('COM_VERTEXUPDATE_VIEW_ERROR_OPENING_UPDATE'), 'error');
        }
    }
    private function pull_update() {
        $link = 'http://www.shape5.com/vertex/patch/Shape5_Vertex4_Patch.zip';
        if(copy($link, JPATH_COMPONENT_ADMINISTRATOR . "/update.zip")) {
            return true;
        } else {
            return false;
        }
    }
}
